
%SUBTTL "⥬ ⠭ FCOS."
%NEWPAGE


;  ᥫ஢.
SEGfcGDT  EQU  008h      ; GDT_SEG.
SEGmemAL  EQU  010h      ; 0..4GB.
SEGfcDAT  EQU  018h      ; DATA.
SEGtbDAT  EQU  020h      ; [TEXT].
SEGfcSTK  EQU  028h      ; STK.
SEGfcCOD  EQU  030h      ; CODE.
COD       EQU  SEGfcCOD  ;  ⪮.
SEG_i740  EQU  038h      ; [GRAPHICS].
SEGalCOD  EQU  040h      ; [ALIACE CODE].
SEGfcTBR  EQU  048h      ; SEG_TBR.
SEGfcTSA  EQU  050h      ; [ALIACE SEG_TSS].
SEGfcMSC  EQU  058h      ; SEG_MOUS.
SEGfcWND  EQU  060h      ; SEG_WIND.
SEGfcKBD  EQU  068h      ; SEG_KEYB.

SEG_Tv86  EQU  1E0h      ; TSS V86.
SEG_Iv86  EQU  1E8h      ; IDT V86.
SEG_Dv86  EQU  1F0h      ; DYNAMIC V86.
SEG_Sv86  EQU  1F8h      ; STACK V86 LEVEL 0.
SEG_TSS0  EQU  200h      ; SEG_TSS 0.
SEG_LDT0  EQU  208h      ; LDT0_SEG.


; ਡ  ᠭ ਯ஢ ᥣ⮢.
dscrNORM  EQU  00000000b ; 訥 ਡ  ᥣ  㬮砭.
dscrCODE  EQU  10011010b ;    ࠧ襭 ⥭.
dscrDATA  EQU  10010010b ;  ᥣ .
dscrSTCK  EQU  10010010b ;  ⥪.            !!! 10010110b !!!

dscrLDTR  EQU  10000010b ;   ਯ஢.
dscrTSKo  EQU  10001001b ;  ᥣ ﭨ .
;dscrTSKc  EQU  10001011b ;  ᥣ ﭨ .
;dscrCALL  EQU  11101100b ;  맮 i386.
dscrINTR  EQU  10001110b ;  뢠 i386.
dscrTRAP  EQU  10001111b ;  誨 i386.

;dsc3CODE  EQU  11111010b ;    ࠧ襭 ⥭.
;dsc3DATA  EQU  11110010b ;  ᥣ .
;dsc3STCK  EQU  11110010b ;  ⥪.            !!! 10010110b !!!
dsc3TSKo  EQU  11101001b ;  ﭨ .
;dsc3INTR  EQU  11101110b ;  뢠 i386.


; ⥬ ⠭.
iDOS      EQU      021h        ; 맮 㭪樨 MS-DOS.
SC_ICW    EQU       15         ; ⢮ 䥩 ⮣ࠬ.
SC_CUR    EQU       20         ; ⢮ 㪠⥫ .
STK_SIZE  EQU    32768         ;  ⥪  FCOS MAIN 386 (TASK0).
HSVstrtI  EQU     040h         ; 砫 뢠 HSV.
WnStkSco  EQU      256         ; ⢮ ६  .
WnStkSiz  EQU WnStkSco*WINSTKLN; ⢮ ६  .
STK86SZ0  EQU     2048         ;  ⥪ V86 LEVEL0.
STK86SZ3  EQU     2048         ;  ⥪ V86 LEVEL3.
ADDSTK02  EQU  12+4+12         ;   INTfcSTA.
ACCESSFL  EQU     4096         ;    짮⥫.
BOOTRNLN  EQU    32768         ;  䠩  ⥬ 業ਥ.
TerminLN  EQU     3072         ;     "Terminal".
DecoraLN  EQU      192         ;     "Decorat".
KEYMAXSC  EQU       64         ; ⢮ ᨬ   .
NoSwTask  EQU        0         ;   ४祭 .
GoSwTask  EQU        1         ; 襭 ४祭 .
EmptyDsc  EQU        0         ; ਧ ᢮ ਯ  ⠡...


;  ६ (  OneVarST.OneVarTp).
OneVarBd  EQU    0       ;  ,  .
OneVarBh  EQU    1       ;  ⭠.
OneVarBs  EQU    2       ;  ,  .
OneVarBb  EQU    3       ;  .
OneVarWd  EQU    4       ;  筮,  .
OneVarWh  EQU    5       ;  ⭠筮.
OneVarWs  EQU    6       ;  筮,  .
OneVarWb  EQU    7       ;  筮.
OneVarDd  EQU    8       ;  ᫮ 筮,  .
OneVarDh  EQU    9       ;  ᫮ ⭠筮.
OneVarDs  EQU   10       ;  ᫮ 筮,  .
OneVarDb  EQU   11       ;  ᫮ 筮.
OneVarSz  EQU   64       ; ASCIIZ-ப.


;  訡  QuitErr.
ErrNorml  EQU  0               ; ଠ쭮 襭.
ErrHighM  EQU  1               ; 筮 孥 .
ErrBaseM  EQU  2               ; 筮  .
ErrXMSdr  EQU  3               ;  ࠩ "himem.sys".
ErrDskSp  EQU  4               ;    ᪥.
ErrGenPr  EQU  5               ; 訡 饩 .
ErrSVGAf  EQU  6               ; 㭪 SVGA ন.
ErrMouse  EQU  7               ;   ࠡ⠥.
ErrHSVdr  EQU  8               ; 맢 㭪 HSV,  ࠩ .
ErrHSVfn  EQU  9               ;  㭪 HSV  ন.
ErrCPUns  EQU  10              ;   ন ( i386+).
ErrOpenF  EQU  16              ;    䠩.
ErrClosF  EQU  17              ;    䠩.
ErrCreaF  EQU  18              ;   ᮧ 䠩.
ErrDeltF  EQU  19              ;   㤠 䠩.
ErrReadF  EQU  20              ;    䠩.
ErrWritF  EQU  21              ;     䠩.
ErrReNmF  EQU  22              ;   २ 䠩.
ErrFindP  EQU  23              ;    .
ErrFnFst  EQU  24              ;     䠩.
ErrFnNxt  EQU  25              ;    ᫥騩 䠩.
ErrSeekF  EQU  26              ;   樮஢  䠩.
ErrCreaD  EQU  28              ;   ᮧ ⠫.
ErrRemvD  EQU  29              ;   㤠 ⠫.
ErrFormN  EQU  30              ;   ଠ஢.
ErrReady  EQU  31              ; ன⢮  ⮢.


; ⠭-न  ࠭.
MAXSCRNX  EQU  799             ; ᫥ 㯭 न
MAXSCRNY  EQU  599             ;    ࠭.
ENDBAR_X  EQU  553             ;   ⮣ࠬ DL.
DOWNLINY  EQU  578             ; Y-न 砫 DL.
TIMECRDX  EQU  786             ; न 襣
TIMECRDY  EQU  583             ;  ࠧ鸞 ᥪ㭤.
COLMENXB  EQU  216             ;  न 梥⮢ 
COLMENYB  EQU  0               ;    SetUp Window \color.
_clDeIni  EQU   clBLACK                ;  Robocop'  ⨨ FCOS.
_clWnOpn  EQU   clL_BLUE               ;  Robocop'  ⨨ .
_clWnCls  EQU   clGREEN                ;  Robocop'  ⨨ .
_cl3Dk12  EQU   clD_GRAY*256+clL_GRAY  ; 
_cl3Dk34  EQU   clBLACK*256+clWHITE    ;  ࠭
_cl3Dk56  EQU   clL_GRAY*256+clD_GRAY  ;  嬥୮
_cl3Dk78  EQU   clWHITE*256+clBLACK    ;  .


;   'Message Windows'.
SCmwFMWp  EQU    10            ; ⢮ ⮣ࠬ Message Windows.
SCmwFMWw  EQU     3            ; ⢮  Message Windows.
WmwRGWN   EQU     0            ;   Registraton.
;W_TASK    EQU     1            ;   TASK.
;W_MEMO    EQU     2            ;   MEMO.
SmwRGWN   EQU     0            ; ⮣ࠬ  Registraton.
;S_TASK    EQU     3            ; ⮣ࠬ  'Task Manager'.
;S_MEMO    EQU     9            ; ⮣ࠬ  'Memory Manager'.
;P_TASK    EQU     0            ;  ⮣ࠬ TASK.
;P_MEMO    EQU     1            ;  ⮣ࠬ MEMO.
;P_QUIT    EQU     2            ;  ⮣ࠬ QUIT.
;P_TINFO   EQU     0            ;  ⮣ࠬ INFO.
;P_TMEMO   EQU     1            ;  ⮣ࠬ MEMO.
;P_TKILL   EQU     2            ;  ⮣ࠬ KILL.
;P_TREST   EQU     3            ;  ⮣ࠬ REST.
;P_TDBUG   EQU     4            ;  ⮣ࠬ DBUG.
;P_TQUIT   EQU     5            ;  ⮣ࠬ QUIT.
;P_MQUIT   EQU     0            ;  ⮣ࠬ QUIT.


;   'System Window'.
SC_DLTp   EQU    10            ; ⢮ ⮣ࠬ DownLineTaskbar.
SC_DLTw   EQU     3            ; ⢮  DownLineTaskbar.
W_FCOS    EQU     0            ;   Sys.
W_TASK    EQU     1            ;   TASK.
W_MEMO    EQU     2            ;   MEMO.
S_FCOS    EQU     0            ; ⮣ࠬ  'System Window'.
S_TASK    EQU     3            ; ⮣ࠬ  'Task Manager'.
S_MEMO    EQU     9            ; ⮣ࠬ  'Memory Manager'.
P_TASK    EQU     0            ;  ⮣ࠬ TASK.
P_MEMO    EQU     1            ;  ⮣ࠬ MEMO.
P_QUIT    EQU     2            ;  ⮣ࠬ QUIT.
P_TINFO   EQU     0            ;  ⮣ࠬ INFO.
P_TMEMO   EQU     1            ;  ⮣ࠬ MEMO.
P_TKILL   EQU     2            ;  ⮣ࠬ KILL.
P_TREST   EQU     3            ;  ⮣ࠬ REST.
P_TDBUG   EQU     4            ;  ⮣ࠬ DBUG.
P_TQUIT   EQU     5            ;  ⮣ࠬ QUIT.
P_MQUIT   EQU     0            ;  ⮣ࠬ QUIT.


;   'SetUp Window'.
SC_SUWp   EQU    13            ; ⢮ ⮣ࠬ SetUp Window.
SC_SUWw   EQU     4            ; ⢮  SetUp Window.
WsSUWN    EQU     0            ;   SetUp Window \main.
WsCOLR    EQU     1            ;   SetUp Window \color.
WsFONT    EQU     2            ;   SetUp Window \font.
WsINFO    EQU     3            ;   SetUp Window \info.
SsSUWN    EQU     0            ; ⮣ࠬ  SetUp Window \main.
SsCOLR    EQU     7            ; ⮣ࠬ  SetUp Window \color.
SsFONT    EQU    10            ; ⮣ࠬ  SetUp Window \font.
;SsINFO    EQU    10            ; ⮣ࠬ  SetUp Window \info.
P_SCOLR   EQU     0            ;  ⮣ࠬ COLOR.
P_SFONT   EQU     1            ;  ⮣ࠬ FONT.
P_SINFO   EQU     2            ;  ⮣ࠬ INFO.
P_SQUIT   EQU     6            ;  ⮣ࠬ INFO.
