
%SUBTTL "樠  ஢."
%NEWPAGE


; InitTask ன TSS  0, V86.
; Ini8259A ९ணࠬ஢ ஫ 뢠 Intel8259A.
; IdentCPU । ⨯ CPU ( Real Mode).
; PrCPU_ID 뤠  stdout ᮮ饭  ⨯ CPU.
; ProtMode 室   ०.
; RealMode 室  ॠ ०.


ASSUME    DS:DATA


; ன TSS  0, V86.
InitTask  PROC NEAR
          PUSH  AX BX DS

    ; ।⥫ ன   .
          MOV   AX,SEG_LDT0        ; 㧨 㪠⥫
          LLDT  AX                 ;   ⠡ LDT  0.
          MOV   AX,SEG_TSS0        ; 㧨 ॣ  TR
          LTR   AX                 ;  ᥫ஬ TSS ᭮ .
          PUSHF                    ; ⠭
          POP   AX                 ;  䫠 NT,
          OR    AX,04000h          ;  ⮡ 㪠,
          PUSH  AX                 ;   
          POPF                     ;  .
          CLTS                     ;  䫠 ⥪ ᮯ.

    ;  室  TSS  .
          MOV   AX,SEGfcTSA        ;  ᭮ ਯ
          MOV   DS,AX              ;  ᥣ , ᮤঠ饣
ASSUME    DS:SEG_TSS               ;  ᥣ ﭨ .

    ; V86 -  ࠡ  BIOS  MS-DOS.
          MOV   BX,OFFSET tss86
          MOV   [BX.tss__eip],OFFSET _beg_V86
          MOV   [BX.tss___cs],CODTSK86
          MOV   [BX.tss_esp0],STK86SZ0
          MOV   [BX.tss__ss0],SEG_Sv86
          MOV   [BX.tss__esp],STK86SZ3
          MOV   [BX.tss___ss],STK3_V86
          MOV   [BX.tss__efl],000023200h ; VM=1, NT=0, IOPL=3, IF=1.
          MOV   [BX.tss___ds],0A000h     ;DATA V86
          MOV   [BX.tss_a_io],104        ;!!! 104+data fcos !!!!!

    ;  0: (386) - SuperVisor.
          MOV   BX,OFFSET tss0         ;  TSS  0.
          MOV   [BX.tss_ldtr],SEG_LDT0 ;  LDT.
          MOV   [BX.tss_prnm],1        ; FCOS-ਮ.
          MOV   [BX.tss_prtm],1        ; 騩 ਮ.
          MOV   [BX.tss_prev],0        ;  ।饩 .
          MOV   [BX.tss_nxts],0        ;  ᫥饩 .

          POP   DS BX AX
          RET
InitTask ENDP


; ९ணࠬ஢ ஫ 뢠 Intel8259A.
; 室: CL-  , CH-  稭񭭮.
Ini8259A PROC NEAR
          PUSH  AX DX
          MOV   DX,020h            ;   饣 ஫.
          MOV   AL,00010001b       ; ICW1: ࠢ騥 ᫮ ICW3  ICW4
          OUT   DX,AL              ;    ᫥⥫쭮.
          INC   DX                 ; ன  饣 ஫.
          MOV   AL,CL              ; ICW2:  祭  .
          OUT   DX,AL              ;   饣 ஫.
          MOV   AL,00000100b       ; ICW3:  ஫
          OUT   DX,AL              ;  砥  IRQ2.
          MOV   AL,00000001b       ; ICW4:  i80x86;
          OUT   DX,AL              ;  EOI 뤠 ࠡ稪 짮⥫.
          MOV   AL,00000000b       ; ᪠ 뢠:
          OUT   DX,AL              ;   ࠧ襭.
          MOV   DX,0A0h            ;    ஫.
          MOV   AL,00010001b       ; ICW1: ࠢ騥 ᫮ ICW3  ICW4
          OUT   DX,AL              ;    ᫥⥫쭮.
          INC   DX                 ; ன   ஫.
          MOV   AL,CH              ; ICW2:  祭  .
          OUT   DX,AL              ;    ஫.
          MOV   AL,00000010b       ; ICW3:  ஫
          OUT   DX,AL              ;  砥  IRQ2.
          MOV   AL,00000001b       ; ICW4:  i80x86;
          OUT   DX,AL              ;  EOI 뤠 ࠡ稪 짮⥫.
          MOV   AL,00000000b       ; ᪠ 뢠:
          OUT   DX,AL              ;   ࠧ襭.
          POP   DX AX
          RET
Ini8259A ENDP


; । ⨯ CPU ( Real Mode).
IdentCPU PROC NEAR
          PUSHAD
          MOV   AX,SEG cpuidVID        ;  
          MOV   DS,AX                  ;   .
ASSUME   DS:DATA

    ; ஢ઠ  "ॢ" ⨯ ஢.
          PUSHFD                       ; ࠭ 
          POP   EDX                    ;  ᫥騥 ࠡ⪨
          MOV   [cpuidFLG],EDX         ;  ७ ॣ 䫠.

    ; ஢ઠ  i8086.
          XOR   AL,AL                  ; =0 -  室
          MOV   [cpuidOLD],AL          ;  祭 i8086.
          MOV   ECX,EDX                ; ᫨  12..15
          AND   CH,00Fh                ;  EFLAGS ᥣ
          mTSTFLAG                     ;  ⠢ (=1),
          AND   CH,0F0h                ;    ,
          JNZ   @@ret                  ;    i8086.

    ; ஢ઠ  i80286.
          MOV   AL,2                   ; =2 -  室
          MOV   [cpuidOLD],AL          ;  祭 i80286.
          MOV   ECX,EDX                ; ᫨  12..15
          OR    CH,0F0h                ;  EFLAGS ᥣ
          mTSTFLAG                     ;  襭 (=0),
          AND   CH,0F0h                ;    ,
          JZ    @@ret                  ;    i80286.

    ; ஢ઠ  i80386.
          INC   [cpuidOLD]             ; =3 -  室
          MOV   ECX,EDX                ;  祭 ⨯
          XOR   ECX,000040000h         ;  CPU - i80386.
          mTSTFLAG                     ; ᫨  18 EFLAGS
          XOR   ECX,EDX                ;   ,
          JZ    @@ret                  ;    i80386.

    ; ஢ઠ  ࠭ i80486.
          INC   [cpuidOLD]             ; =4 -  室
          MOV   ECX,EDX                ;  祭 i80486.
          XOR   ECX,000200000h         ; ᫨  21 EFLAGS
          mTSTFLAG                     ;   ,
          XOR   ECX,EDX                ;    CPUID
          JZ    @@ret                  ;   ন.

    ; 祭 ଠ樨   CPUID.
@@cpuid : MOV   AL,255                 ; 祭 ଠ
          MOV   [cpuidOLD],AL          ;    CPUID.
          MOV   EAX,000000000h         ;  맮 -
          CPUID                        ;  砫쭠 ଠ.
          MOV   [cpuidScI],EAX         ; ᨬ EAX  CPUID.
          MOV   PD [cpuidVID+0],EBX    ; 12 ASCII ᨬ -
          MOV   PD [cpuidVID+4],EDX    ;  ⪠ (ᨣ)
          MOV   PD [cpuidVID+8],ECX    ;  ந⥫ .

;    ...
          MOV   EAX,000000001h         ; .
          CPUID                        ; .
          MOV   [cpuidIDP],EAX         ;  䨪樨 .

@@ret :   POPAD
          RET
IdentCPU ENDP


; 뤠  stdout ᮮ饭  ⨯ CPU.
PrCPU_ID PROC NEAR
          PUSHAD
          MOV   AX,SEGfcDAT            ;  
          MOV   DS,AX                  ;   .
ASSUME   DS:DATA

    ;  ᮮ饭  ᥪ樨 CPU.
          MOV   DX,SEG cpuidMs0        ; 뤠
          MOV   CX,OFFSET cpuidMs0     ;  ᮮ饭
          MOV   AX,iDOSstout           ;   
          INT   INTfcBas               ;  stdout

    ; ᫨   ন CPUID.
          CMP   [cpuidOLD],255         ; ⤥쭮 祭
          JNE   @@oldcpu               ;  ⨯ ண CPU.

    ; ந⥫ CPU.
          MOV   DX,SEG cpuidMs1        ; 뤠  stdout
          MOV   CX,OFFSET cpuidMs1     ;  ࣮ ન
          MOV   AX,iDOSstout           ;  ந⥫
          INT   INTfcBas               ;  .

    ;  䨪樨 .
          MOV   DX,SEG cpuidMs2        ; 뤠  stdout
          MOV   CX,OFFSET cpuidMs2     ;   ,
          MOV   AX,iDOSstout           ;   
          INT   INTfcBas               ;  ⥯.

    ; 뤠 "" .
          MOV   EAX,[cpuidIDP]         ; 32  .
          CALL  PrAllHex               ; 뢮 ᫠  HEX .

    ;  " ".
          MOV   DX,SEG cpuidMs3        ; 뤠  stdout
          MOV   CX,OFFSET cpuidMs3     ;   
          MOV   AX,iDOSstout           ;  ஢
          INT   INTfcBas               ;  ⨯ CPU.

    ; ஢ ⨯.
          MOV   EAX,[cpuidIDP]         ;  䨪樨 .
          MOV   EBX,OFFSET cpuidTyp    ;  ᮮ⢥⢨ .
@@next :  MOV   DX,[EBX]               ; 﫨   ⠡
          OR    DX,DX                  ; ᫨ ⠡ 稫,
          JZ    @@find                 ;     .
          AND   DL,11110000b           ; ᪨஢  ⥯.
          AND   AL,11110000b           ;    ਣ.
          CMP   AX,DX                  ; ᫨  ।,
          JE    @@find                 ;  뤠  ⨯.
          MOVZX EDX,PB [EBX+2]         ; 
          ADD   EBX,EDX                ;  த
          JMP   @@next                 ;  .

@@find :  MOV   DX,SEG cpuidTyp        ; 뤠
          LEA   CX,[BX+3]              ;  ஢
          MOV   AX,iDOSstout           ;  ⨯ 
          INT   INTfcBas               ;  stdout.

@@end :   POPAD
          RET

@@oldcpu: CMP   [cpuidOLD],4           ;   砥, ᫨
          JA    @@end                  ;    ।

    ; ⤥쭮 祭  ⨯ ண CPU.
;    ...
          JMP   @@end

PrCPU_ID ENDP


; 室   ०.
ProtMode PROC NEAR
          PUSHAD

    ;  뤥   MS-DOS.
          MOV   BX,zzzzzzzz            ; ந ।
          MOV   AX,ES                  ;   MS-DOS.  뭥 FCOS
          SUB   BX,AX                  ;  ਭ   ,
          MOV   AH,04Ah                ;   ⮫쪮 ॠ쭮 .
          INT   021h                   ;  ⠫쭮 -  ਫ.

    ;  ⠡  ਯ஢.
          MOV   AX,GDT_SEG             ; 
          MOV   DS,AX                  ;  GDT.
ASSUME    DS:GDT_SEG
          LoadDesc GDT__GDT, GDT_SEG , GDT_Size -1 ; GDT_SEG
          LoadDesc GDT__DAT, DATA    , DataSize -1 ; DATA
          LoadDesc GDT__STK, STK     , STK_SIZE -1 ; STK
          LoadDesc GDT__COD, CODE    , CodeSize -1 ; CODE
          LoadDesc GDT__ALS, CODE    , CodeSize -1 ; [ALIACE CODE]
          LoadDesc GDT__TBR, SEG_TBR , SgTBRsiz -1 ; TASK_BAR DATA
          LoadDesc GDT__TSA, SEG_TSS , tss_size -1 ; [ALIACE SEG_TSS]
          LoadDesc GDT__MSC, SEG_MOUS, MousSize -1 ; MOUSE DATA
          LoadDesc GDT__WND, SEG_WIND, WnStkSiz -1 ; WINDOWS STACK
          LoadDesc GDT__KBD, SEG_KEYB, KeybSize -1 ; KEYBOARD DATA
          LoadDesc GDTsvMAT, SEG_MATH, MathSize -1 ; HSV\Mathem.CODE

          LoadDesc GDT_Tv86, SEG_TSS , tss0-tss86-1; [TSS_V86]
          LoadDesc GDT_Sv86, STK0_V86, STK86SZ0 -1 ; STK V86 LEVEL0.
          LoadDesc GDT_TSS0, SEG_TSS , TSS_LENG-1  ; [TSS_0]
          LoadDesc GDT_LDT0, LDT0_SEG, LDT0Size -1 ; LDT0_SEG
          ADD   [PD GDT_TSS0.DescBas1],LARGE OFFSET tss86
          ADD   [PD GDT_TSS0.DescBas1],LARGE OFFSET tss0

    ;  ⠡  ਯ஢  0.
          MOV   AX,LDT0_SEG                        ; 
          MOV   DS,AX                              ;  GDT.
ASSUME    DS:LDT0_SEG
          LoadDesc LDT_DT0a, DATA    , 15          ; DAT0

    ; ன 뢠.
COMMENT `
          MOV   AX,03509h              ;   009h.
          INT   iDOS                   ; 稫  祭.
          MOV   AX,SEG OldI009h        ; ࠭
          MOV   DS,AX                  ;  ஥
ASSUME    DS:SEG OldI009h              ;  祭
          MOV   [PW OldI009h],BX       ;  
          MOV   [PW OldI009h+2],ES     ;  009h.
          MOV   AX,SEG KeybBIOS        ; ⠭
          MOV   DS,AX                  ;  
          MOV   DX,OFFSET KeybBIOS     ;  
          MOV   AX,02509h              ;  ࠡ稪
          INT   iDOS                   ;  .
`
          CLI                          ;   뢠.
          MOV   CX,02820h              ;    
          CALL  Ini8259A               ;   稭񭭮 ஫஢.


    ; 㧪  Global Descriptor Table Register (GDTR).
          MOV  AX,DATA                 ; DOS-ᥣ,
          MOV  DS,AX                   ;  ᮤঠ騩 ⠡
ASSUME    DS:DATA                      ;   ਯ஢.
          XOR  EAX,EAX                 ; 稫  
          MOV  AX,GDT_SEG              ;  ᥣ GDT (=DOSseg*16).
          SHL  EAX,4                   ;  
          MOV  [GDTpoint.GDTR_Adr],EAX ;  㪠⥫ GDT.
          LGDT [GDTpoint]              ; 㧨 GDT.

    ; 㧪  Interrupt Descriptor Table Register (IDTR).
          XOR  EAX,EAX                 ; 稫  
          MOV  AX,IDT_SEG              ;  ᥣ IDT (=DOSseg*16).
          SHL  EAX,4                   ;  
          MOV  [IDTpoint.GDTR_Adr],EAX ;  㪠⥫ IDT.
          LIDT [IDTpoint]              ; 㧨 IDT.

    ; ४祭  饭 ० (Protected Mode).
          MOV  EAX,CR0                 ; ⠭
          OR   AL,00000001b            ;  䫠
          MOV  CR0,EAX                 ;  ०.

    ; ன ॣ CS   .
          DB   0EAh                    ; 設   JMP.
          DW   OFFSET @@p_pm           ; 饭  ᥣ .
          DW   SEGfcCOD                ;    ⠡ GDT.

    ; 㧪 ᥫ஢  ⠫ ਯ஢.
@@p_pm :  MOV  AX,SEGfcDAT             ; DATA
          MOV  DS,AX
          MOV  AX,SEGtbDAT             ; TEXT
          MOV  ES,AX
          MOV  AX,SEGfcSTK             ; STACK
          MOV  SS,AX
          MOV  AX,SEGalCOD             ; ALIAS CODE
          MOV  FS,AX
          MOV  AX,SEG_i740             ; GRAPHICS
          MOV  GS,AX

          CALL  InitTask               ; ன TSS  0, V86.
          STI                          ; 蠥 뢠.
          POPAD
          RET
ProtMode ENDP


; 室  ॠ ०.
RealMode PROC NEAR
          PUSHAD
          IN    AL,061h                ;  ﭨ
          AND   AL,11111100b           ;  - 몫祭
          OUT   061h,AL                ;    ⠩.

    ; ன 뢠.
          CLI                          ;   뢠.
          MOV   CX,07008h              ;    뢠 
          CALL  Ini8259A               ;    稭 ஫஢.

          MOV   AX,iDeInMem            ; ⨫ 
          INT   INTfcMem               ;   孥 .

    ; ନ஢ ਯ஢  ॠ쭮 ०.
          MOV  AX,008h                     ; 
          MOV  DS,AX                       ;  ᥣ
ASSUME    DS:GDT_SEG                       ;  ॠ쭮
          MOV  [GDT__DAT.DescLim1],0FFFFh  ;  ०
          MOV  [GDT__STK.DescLim1],0FFFFh  ;  
          MOV  [GDT__COD.DescLim1],0FFFFh  ;  
          MOV  [GDT__TXT.DescLim1],0FFFFh  ;  
          MOV  [GDT__GFX.DescLim1],0FFFFh  ;  64k.
          AND  [GDT__DAT.DescL2A2],0F0h    ; 塞
          AND  [GDT__STK.DescL2A2],0F0h    ;  孨
          AND  [GDT__COD.DescL2A2],0F0h    ;   
          AND  [GDT__TXT.DescL2A2],0F0h    ;  
          AND  [GDT__GFX.DescL2A2],0F0h    ;  ᥣ.

    ; 㧪 ⥭ ਯ஢  Protected Mode.
ASSUME    DS:DATA
          MOV  AX,SEGfcDAT             ; DATA
          MOV  DS,AX
          MOV  AX,SEGfcSTK             ; STACK
          MOV  SS,AX
          MOV  AX,SEGfcDAT             ; DATA
          MOV  ES,AX
          MOV  AX,SEGfcDAT             ; DATA
          MOV  FS,AX
          MOV  AX,SEGfcDAT             ; DATA
          MOV  GS,AX

    ; ॢ ᯮ  ॠ ०.
          DB   0EAh                    ; JMP              // 客.
          DW   OFFSET @@p_rj           ;     SEGfcCOD:
          DW   SEGfcCOD                ;              @@p_rj.
@@p_rj :  MOV  EAX,CR0                 ; 
          AND  AL,11111110b            ;  䫠
          MOV  CR0,EAX                 ;  ०.
          DB   0EAh                    ; JMP              // ॠ 
          DW   OFFSET @@p_rm           ;     CODE:
          DW   CODE                    ;          @@p_rm.

    ; 㧪 ⥭ ਯ஢  Real Mode.
@@p_rm :  MOV  AX,DATA                 ; DATA
          MOV  DS,AX
          MOV  AX,STK                  ; STACK
          MOV  SS,AX
          MOV  AX,DATA                 ; DATA
          MOV  ES,AX
          MOV  AX,DATA                 ; DATA
          MOV  FS,AX
          MOV  AX,DATA                 ; DATA
          MOV  GS,AX

    ;  뢠  ॠ쭮 ०.
          MOV  AX,00400h -1            ; 㧨 ॣ
          MOV  [IDTpoint.GDTR_Lim],AX  ;  IDT 祭
          XOR  EAX,EAX                 ;  ⠭⭮ ⠡
          MOV  [IDTpoint.GDTR_Adr],EAX ;  뢠 ॠ쭮
          LIDT [IDTpoint]              ;  ० (256x4)

          POPAD
          STI                          ; 蠥 뢠.
          RET
RealMode ENDP
