
SUBTTL "Private coding procedure for Fwcs Miner Game."

ASSUME   DS:DATA,ES:NOTHING,FS:NOTHING,GS:NOTHING


; 砫  .
StartGam PROC NEAR
          PUSHAD
          PUSH  DS
          MOV   AX,SEGfmgDT
          MOV   DS,AX

          MOV   [Level],1              ;  ஢.
          CALL  IniGam                 ; 樠 .

          POP   DS
          POPAD
          RET
StartGam ENDP


; 樠 .
IniGam   PROC NEAR
          PUSHA
          PUSH  DS ES
          MOV   AX,SEGfmgDT            ; ந ᥫ
          MOV   DS,AX                  ;  ਯ஢ ᥣ⮢
          MOV   AX,SEGfmgED            ;  樠஢ 
          MOV   ES,AX                  ;  樠஢ .

          CALL  IniLev                 ; 樠 ஢.
          CALL  IniPol                 ; ⪠ ஢ .
          CALL  RndBom                 ; ⠭ .
          CALL  ClcBmb                 ;   .
          CALL  PrnPol                 ; ᮢ ஢ .
          CALL  Prn_St
          CALL  PrnBom
          CALL  PrnLiv
          CALL  PrnLev

          POP   DS ES
          POPA
          RET
IniGam   ENDP


; 樠 ஢.
IniLev   PROC NEAR
          PUSH  AX BX

          MOV   AX,[Level]
          IMUL  AX,5
          ADD   AX,45
          MOV   [Bom],AX

          MOV   BX,361
          SUB   BX,AX
          MOV   [St],BX

          MOV   AX,[Level]
          MOV   BX,6
          SUB   BX,AX
          MOV   [Live],BX

          POP   BX AX
          RET
IniLev   ENDP


; ⪠ ஢ .
IniPol   PROC NEAR
          PUSH  AX EBX CX

          MOV   CX,[SizeSpcX]
          MOV   AX,[SizeSpcY]
          ADD   CX,2
          ADD   AX,2
          IMUL  CX,AX

          MOV   EBX,Pole
@@l :     MOV   ES:[EBX],PB Field0
          INC   EBX
          LOOP  @@l

          POP   CX EBX AX
          RET
IniPol   ENDP


; ⠭ .
RndBom   PROC NEAR
          PUSH  AX BX CX DX ESI
          MOV   CX,[Bom]
@@loop :  PUSH  CX

@@err :   MOV   CX,[SizeSpcY]
          CALL  GtNxtRnd
          INC   CX
          MOV   DX,CX

          MOV   CX,[SizeSpcX]
          CALL  GtNxtRnd
          INC   CX
          MOV   BX,CX

          CALL  GetAdres
          MOV   AL,ES:[ESI]
          CMP   AL,FieldM
;          JE    @@err

          MOV   ES:[ESI],PB FieldM
          POP   CX
          LOOP  @@loop

          POP   ESI DX CX BX AX
          RET
RndBom   ENDP


;   .
ClcBmb   PROC NEAR
          PUSH  BX CX DX

          MOV   DX,1
@@ly :    MOV   BX,1
@@lx :    CALL  GetAdres
          CMP   ES:[ESI],PB FieldM
          JE    @@obh

          CALL  ScAround
          ADD   CL,Field0
          MOV   ES:[ESI],CL

@@obh :   INC   BX
          CMP   BX,[SizeSpcX]
          JLE   @@lx
          INC   DX
          CMP   DX,[SizeSpcY]
          JLE   @@ly

          POP   DX CX BX
          RET
ClcBmb   ENDP


; ᮢ ஢ .
PrnPol   PROC NEAR
          PUSH  AX BX CX DX ESI BP
          MOV   AX,iResMouse           ; ⠫
          INT   INTfcMou               ;  㪠⥫ .

          MOV   SI,[SizeSpcX]
          ADD   SI,3
          MOVZX ESI,SI
          ADD   ESI,Pole
          MOV   DX,[BegCrd_Y]
          MOV   BP,[SizeSpcY]

@@ly :    MOV   BX,[BegCrd_X]
          MOV   CX,[SizeSpcX]
@@lx :    MOV   AL,ES:[ESI]
          MOV   AH,AL
          SHR   AH,6
          JZ    @@hit
          AND   AL,00001111b
          JMP   @@prn
@@hit :   MOV   AL,FieldN
@@prn :   CALL  PrnFld                 ; ᮢ  .
          ADD   BX,[ScaleX]
          INC   ESI
          LOOP  @@lx

          ADD   DX,[ScaleY]
          ADD   ESI,2
          DEC   BP
          JNZ   @@ly

          MOV   AX,iSetMouse           ; 
          INT   INTfcMou               ;  㪠⥫ .
          POP   BP ESI DX CX BX AX
          RET
PrnPol   ENDP


; 樠.
Prn_St   PROC NEAR
          RET
Prn_St   ENDP


; 樠.
PrnBom   PROC NEAR
          RET
PrnBom   ENDP


; 樠.
PrnLiv   PROC NEAR
          RET
PrnLiv   ENDP


; 樠.
PrnLev   PROC NEAR
          RET
PrnLev   ENDP


; ᮢ  .
; 室 : (BX,DX) - न ; AL -  .
PrnFld   PROC NEAR
          PUSH  AX ECX
          PUSH  AX
          MOV   AX,iResMouse           ; ⠫
          INT   INTfcMou               ;  㪠⥫ .
          POP   AX

          MOVZX AX,AL
          MOV   CX,SZW
          IMUL  CX,AX
          MOVZX ECX,CX
          ADD   ECX,GfxField

          MOV   AX,iPutBoxWn
          INT   INTfcScr

          MOV   AX,iSetMouse           ; 
          INT   INTfcMou               ;  㪠⥫ .
          POP   ECX AX
          RET
PrnFld   ENDP


; । न .
; 室 : (BX,DX) - न   .
; 室: (BX,DX) - न   ஢ .
GetPosit PROC NEAR
          PUSH  AX CX
          SUB   BX,[BegCrd_X]
          SUB   DX,[BegCrd_Y]

          MOV   CL,PB [ScaleX]
          MOV   AX,BX
          IDIV  CL
          INC   AL
          MOVZX BX,AL

          MOV   CL,PB [ScaleY]
          MOV   AX,DX
          IDIV  CL
          INC   AL
          MOVZX DX,AL

          POP   CX AX
          RET
GetPosit ENDP


;  न .
; 室 : (BX,DX) - न   ஢ .
; 室: (BX,DX) - न   .
SetPosit PROC NEAR
          DEC   BX
          DEC   DX
          IMUL  BX,[ScaleX]
          IMUL  DX,[ScaleY]
          ADD   BX,[BegCrd_X]
          ADD   DX,[BegCrd_Y]
          RET
SetPosit ENDP


; ᫥    ᨢ.
; 室 : (BX,DX) - न   ஢ .
; 室: (ES,ESI) -  .
GetAdres PROC NEAR
          PUSH  EBX DX
          MOV   SI,[SizeSpcX]
          ADD   SI,2
          IMUL  DX,SI

          MOV   ESI,Pole
          MOVZX EBX,BX
          ADD   ESI,EBX
          MOVZX EBX,DX
          ADD   ESI,EBX

          POP   DX EBX
          RET
GetAdres ENDP


; 頥 ᫥饥 ࠭祭 ᥢ砩 ᫮ ( CX).
GtNxtRnd PROC NEAR
          PUSH  AX BX
          MOV   BX,[RandSeed]
          MOV   AX,iModRnd16
          INT   INTfcMat
          MOV   [RandSeed],BX
          POP   BX AX
          RET
GtNxtRnd ENDP


; 頥 ⢮ (CL)    (BX,DX).
ScAround PROC NEAR
          XOR   CL,CL

          DEC   BX
          DEC   DX
          CALL  WhoPosit
          INC   BX
          CALL  WhoPosit
          INC   BX
          CALL  WhoPosit

          INC   DX
          CALL  WhoPosit
          SUB   BX,2
          CALL  WhoPosit

          INC   DX
          CALL  WhoPosit
          INC   BX
          CALL  WhoPosit
          INC   BX
          CALL  WhoPosit

          DEC   BX
          DEC   DX
          RET
ScAround ENDP


; ᫨  (BX,DX) , 㢥稢 CL  .
WhoPosit PROC NEAR
          PUSH  AX ESI
          CALL  GetAdres
          MOV   AL,ES:[ESI]
          CMP   AL,FieldM
          SETE  AL
          ADD   CL,AL
          POP   ESI AX
          RET
WhoPosit ENDP


;   맮 FCOS:HSV\MUSIC\WhtNoise.
WhtNoise PROC NEAR
          PUSH  AX
          MOV   AX,iWhtNoise
          INT   INTfcMus
          POP   AX
          RET
WhtNoise ENDP
