
SUBTTL "Private coding procedure for HSV\mat."


;              .


; 樠 ⥬᪮ ᮯ.
; 室  ᮮ饭 FCOS 室 ࠭ ⥪
;  ᮯ  TSS .    砥  짮
;  ᮯ஬  ।⥫쭮 맮 ⮩ 㭪樨 
;  ᫥ 맮 㭪樨  DeInMath.
; 室:  ॣ ࠭.
InitMath PROC FAR

    ; 訫   ⥬᪮ ᮯ.
          NOP

          FINIT                        ; ᪠ 樠 ᮯ.
          RET
InitMath ENDP


; 樠 ⥬᪮ ᮯ.
DeInMath PROC FAR

    ; ⨫   ⥬᪮ ᮯ.
          NOP

          RET
DeInMath ENDP


;  ᫥饥 ᥢ砩 ᫮.
; 室 : ।饥 ᥢ砩 ᫮ (  BX).
; 室: ᫥饥 ᥢ砩 ᫮ (  BX).
Random16 PROC FAR
          PUSH  AX CX DX
          CALL  random16
          POP   DX CX AX
          RET
Random16 ENDP


;  ࠭祭 ᥢ砩 ᫮.
; 室 : ।饥 ᥢ砩 ᫮    BX;
;        ࠭⥫ (⨦)  CX.
; 室: ᫥饥 ᥢ砩 ᫮ (  BX);
;        ॡ㥬 (࠭祭) ᫮ (  CX).
ModRnd16 PROC FAR
          PUSH  AX DX  CX
          CALL  random16
          POP   CX

          MOV   AX,BX
          XOR   DX,DX
          DIV   CX
          MOV   CX,DX

          POP   DX AX
          RET
ModRnd16 ENDP


; ୮ ᢠ.  BP:ECX = SI:EBX.
VectEquv PROC FAR
          PUSH  EAX DS ES
          MOV   DS,SI
          MOV   ES,BP

          MOV   EAX,DS:[EBX.VECTOR_X]  ; 
          MOV   ES:[ECX.VECTOR_X],EAX  ;  ஢
          MOV   EAX,DS:[EBX.VECTOR_Y]  ;  
          MOV   ES:[ECX.VECTOR_Y],EAX  ;   
          MOV   EAX,DS:[EBX.VECTOR_Z]  ;  ᯮ짮
          MOV   ES:[ECX.VECTOR_Z],EAX  ;  ᮯ.

          POP   ES DS EAX
          RET
VectEquv ENDP


; ࠭稢 न  १ [0,1].  BP:ECX = Clip(SI:EBX).
VectClip PROC FAR
          PUSH  AX DS ES
          MOV   DS,SI
          MOV   ES,DI

          FLDZ                         ; \0
          FLD   DS:[EBX.VECTOR_X]      ; \u.x, 0
          FCOMPP                       ; \---
          FCMPAH                       ; ? u.x<0 ?
          CMP   AH,001h                ;  yes?
          JNE   @@x1                   ; if (no) then goto @@x1
          FLDZ                         ; \0
          FSTP  ES:[ECX.VECTOR_X]      ; \---;  u.x=0
          JMP   @@x0                   ; goto @@x0
@@x1 :    FLD1                         ; \1
          FLD   DS:[EBX.VECTOR_X]      ; \u.x, 1
          FCOMPP                       ; \---
          FCMPAH                       ; ? u.x>1 ?
          CMP   AH,000h                ;  yes?
          JNE   @@x0                   ; if (no) then goto @@x0
          FLD1                         ; \1
          FSTP  ES:[ECX.VECTOR_X]      ; \---;  u.x=1

@@x0 :    FLDZ                         ; \0
          FLD   DS:[EBX.VECTOR_Y]      ; \u.y, 0
          FCOMPP                       ; \---
          FCMPAH                       ; ? u.y<0 ?
          CMP   AH,001h                ;  yes?
          JNE   @@y1                   ; if (no) then goto @@y1
          FLDZ                         ; \0
          FSTP  ES:[ECX.VECTOR_Y]      ; \---;  u.y=0
          JMP   @@y0                   ; goto @@y0
@@y1 :    FLD1                         ; \1
          FLD   DS:[EBX.VECTOR_Y]      ; \u.y, 1
          FCOMPP                       ; \---
          FCMPAH                       ; ? u.y>1 ?
          CMP   AH,000h                ;  yes?
          JNE   @@y0                   ; if (no) then goto @@y0
          FLD1                         ; \1
          FSTP  ES:[ECX.VECTOR_Y]      ; \---;  u.y=1

@@y0 :    FLDZ                         ; \0
          FLD   DS:[EBX.VECTOR_Z]      ; \u.z, 0
          FCOMPP                       ; \---
          FCMPAH                       ; ? u.z<0 ?
          CMP   AH,001h                ;  yes?
          JNE   @@z1                   ; if (no) then goto @@z1
          FLDZ                         ; \0
          FSTP  ES:[ECX.VECTOR_Z]      ; \---;  u.z=0
          JMP   @@z0                   ; goto @@z0
@@z1 :    FLD1                         ; \1
          FLD   DS:[EBX.VECTOR_Z]      ; \u.z, 1
          FCOMPP                       ; \---
          FCMPAH                       ; ? u.z>1 ?
          CMP   AH,000h                ;  yes?
          JNE   @@z0                   ; if (no) then goto @@z0
          FLD1                         ; \1
          FSTP  ES:[ECX.VECTOR_Z]      ; \---;  u.z=1

@@z0 :    POP   ES DS AX
          RET
VectClip ENDP


; ᫥   .  BP:ECX = !(SI:EBX).
VectLeng PROC FAR
          CALL  vectleng
          RET
VectLeng ENDP


; ଠ .  (BP:ECX) = (SI:EBX)*(1/!(SI:EBX)).
; P.S. 室    㫥 ().
VectNorm PROC FAR
          PUSH  EDX DI
          SUB   ESP,4                  ; LOCAL tmp
          PUSH  ECX BP
          LEA   ECX,[ESP+6]
          MOV   BP,SS
          CALL  vectleng               ; SS:tmp = !(SI:EBX)
          FLD1                         ; \1
          FDIV  PD SS:[ECX]            ; \ 1/(!u)
          FSTP  PD SS:[ECX]

          MOV   EDX,ECX
          MOV   DI,BP
          POP   BP ECX
          CALL  vectmuln               ; BP:ECX = u / !u
          ADD   ESP,4                  ; KILL tmp
          POP   DI EDX
          RET
VectNorm ENDP


; ⭮ ᫮ ஢.  BP:ECX = SI:EBX + DI:EDX.
VectAddK PROC FAR
          PUSH  DS ES FS
          MOV   DS,SI
          MOV   ES,DI
          MOV   FS,BP

          FLD   DS:[EBX.VECTOR_X]      ; \u.x
          FADD  ES:[EDX.VECTOR_X]      ; \u.x + v.x
          FSTP  FS:[ECX.VECTOR_X]      ; \---

          FLD   DS:[EBX.VECTOR_Y]      ; \u.y
          FADD  ES:[EDX.VECTOR_Y]      ; \u.y + v.y
          FSTP  FS:[ECX.VECTOR_Y]      ; \---

          FLD   DS:[EBX.VECTOR_Z]      ; \u.z
          FADD  ES:[EDX.VECTOR_Z]      ; \u.z + v.z
          FSTP  FS:[ECX.VECTOR_Z]      ; \---

          POP   FS ES DS
          RET
VectAddK ENDP


; ⭮ ⠭ ஢.  BP:ECX = SI:EBX - DI:EDX.
VectSubK PROC FAR
          PUSH  DS ES FS
          MOV   DS,SI
          MOV   ES,DI
          MOV   FS,BP

          FLD   DS:[EBX.VECTOR_X]      ; \u.x
          FSUB  ES:[EDX.VECTOR_X]      ; \u.x - v.x
          FSTP  FS:[ECX.VECTOR_X]      ; \---

          FLD   DS:[EBX.VECTOR_Y]      ; \u.y
          FSUB  ES:[EDX.VECTOR_Y]      ; \u.y - v.y
          FSTP  FS:[ECX.VECTOR_Y]      ; \---

          FLD   DS:[EBX.VECTOR_Z]      ; \u.z
          FSUB  ES:[EDX.VECTOR_Z]      ; \u.z - v.z
          FSTP  FS:[ECX.VECTOR_Z]      ; \---

          POP   FS ES DS
          RET
VectSubK ENDP


; ⭮ ந ஢.  BP:ECX = SI:EBX * DI:EDX.
VectMulK PROC FAR
          PUSH  DS ES FS
          MOV   DS,SI
          MOV   ES,DI
          MOV   FS,BP

          FLD   DS:[EBX.VECTOR_X]      ; \u.x
          FMUL  ES:[EDX.VECTOR_X]      ; \u.x * v.x
          FSTP  FS:[ECX.VECTOR_X]      ; \---

          FLD   DS:[EBX.VECTOR_Y]      ; \u.y
          FMUL  ES:[EDX.VECTOR_Y]      ; \u.y * v.y
          FSTP  FS:[ECX.VECTOR_Y]      ; \---

          FLD   DS:[EBX.VECTOR_Z]      ; \u.z
          FMUL  ES:[EDX.VECTOR_Z]      ; \u.z * v.z
          FSTP  FS:[ECX.VECTOR_Z]      ; \---

          POP   FS ES DS
          RET
VectMulK ENDP


;    ᫮.  BP:ECX = SI:EBX * ᫮(DI:EDX).
VectMulN PROC FAR
          CALL  vectmuln
          RET
VectMulN ENDP


; ୮ ந ஢.  ᫮(BP:ECX) = SI:EBX & DI:EDX.
VectMulS PROC FAR
          PUSH  DS ES
          MOV   DS,SI
          MOV   ES,DI

          FLD   DS:[EBX.VECTOR_X]      ; \u.x
          FMUL  ES:[EDX.VECTOR_X]      ; \u.x * v.x
          FLD   DS:[EBX.VECTOR_Y]      ; \u.y
          FMUL  ES:[EDX.VECTOR_Y]      ; \u.y * v.y
          FADD
          FLD   DS:[EBX.VECTOR_Z]      ; \u.z
          FMUL  ES:[EDX.VECTOR_Z]      ; \u.z * v.z
          FADD

          MOV   DS,BP
          FSTP  PD DS:[ECX]            ; \---
          POP   ES DS
          RET
VectMulS ENDP


; ୮ ந ஢.  BP:ECX = SI:EBX ^ DI:EDX.
; 室: BP,SI,DI,ECX,EBX,EDX.
; 室 - १  BP:ECX.
; P.S. 室  ⫨  室,  -  .
VectMulV PROC FAR
          PUSH  DS ES FS
          MOV   DS,SI
          MOV   ES,DI
          MOV   FS,BP

          FLD   DS:[EBX.VECTOR_Y]      ; \u.y
          FMUL  ES:[EDX.VECTOR_Z]      ; \u.y * v.z
          FLD   DS:[EBX.VECTOR_Z]      ; \u.z
          FMUL  ES:[EDX.VECTOR_Y]      ; \u.z * v.y
          FSUB                         ; \(u.y * v.z) - (u.z * v.y)
          FSTP  FS:[ECX.VECTOR_X]      ; \---

          FLD   DS:[EBX.VECTOR_Z]      ; \u.z
          FMUL  ES:[EDX.VECTOR_X]      ; \u.z * v.x
          FLD   DS:[EBX.VECTOR_X]      ; \u.x
          FMUL  ES:[EDX.VECTOR_Z]      ; \u.x * v.z
          FSUB                         ; \(u.z * v.x) - (u.x * v.z)
          FSTP  FS:[ECX.VECTOR_Y]      ; \---

          FLD   DS:[EBX.VECTOR_X]      ; \u.x
          FMUL  ES:[EDX.VECTOR_Y]      ; \u.x * v.y
          FLD   DS:[EBX.VECTOR_Y]      ; \u.y
          FMUL  ES:[EDX.VECTOR_X]      ; \u.y * v.x
          FSUB                         ; \(u.x * v.y) - (u.y * v.x)
          FSTP  FS:[ECX.VECTOR_Z]      ; \---

          POP   FS ES DS
          RET
VectMulV ENDP


; ⭮  ஢.  BP:ECX = SI:EBX / DI:EDX.
VectDivK PROC FAR
          PUSH  DS ES FS
          MOV   DS,SI
          MOV   ES,DI
          MOV   FS,BP

          FLD   DS:[EBX.VECTOR_X]      ; \u.x
          FDIV  ES:[EDX.VECTOR_X]      ; \u.x / v.x
          FSTP  FS:[ECX.VECTOR_X]      ; \---

          FLD   DS:[EBX.VECTOR_Y]      ; \u.y
          FDIV  ES:[EDX.VECTOR_Y]      ; \u.y / v.y
          FSTP  FS:[ECX.VECTOR_Y]      ; \---

          FLD   DS:[EBX.VECTOR_Z]      ; \u.z
          FDIV  ES:[EDX.VECTOR_Z]      ; \u.z / v.z
          FSTP  FS:[ECX.VECTOR_Z]      ; \---

          POP   FS ES DS
          RET
VectDivK ENDP


; CX=(boolean)(SI:EBX < DI:EDX)
VectCmKl PROC FAR
          PUSH  DS ES
          MOV   DS,SI
          MOV   ES,DI
COMMENT `
          FLD   [DS:EBX.VECTOR_X]      ; \u.x
          FCOMP [ES:EDX.VECTOR_X]      ; \---;  u.x < v.x
          FCOMPP                       ; \---
          FCMPAH                       ; ? u.x<0 ?
          CMP   AH,001h                ;  yes?
          JNE   @@x1                   ; if (no) then goto @@x1
          FLDZ                         ; \0
          FSTP  [ES:ECX.VECTOR_X]      ; \---;  u.x=0
          JMP   @@x0                   ; goto @@x0
`
          POP   ES DS
          RET
VectCmKl ENDP


;                      .


; ᫥   .  BP:ECX = !(SI:EBX).
vectleng PROC NEAR
          PUSH  DS
          MOV   DS,SI
          FLD   DS:[EBX.VECTOR_X]      ; \u.x
          FMUL  ST,ST                  ; \u.x * u.x
          FLD   DS:[EBX.VECTOR_Y]      ; \u.y, u.x * u.x
          FMUL  ST,ST                  ; \u.y * u.y, u.x * u.x
          FADD                         ; \(u.y * u.y) + (u.x * u.x)
          FLD   DS:[EBX.VECTOR_Z]      ; \u.z, (u.y * u.y)+(u.x * u.x)
          FMUL  ST,ST                  ; \u.z * u.z, (u.y * u.y)+(u.x * u.x)
          FADD                         ; \(u.z*u.z)+(u.y*u.y)+(u.x*u.x)
          FSQRT                        ; \SQRT( () + () + () )
          MOV   DS,BP
          FSTP  PD DS:[ECX]            ; \---
          POP   DS
          RET
vectleng ENDP


;    ᫮.  BP:ECX = SI:EBX * ᫮(DI:EDX).
vectmuln PROC NEAR
          PUSH  DS ES FS
          MOV   DS,SI
          MOV   ES,DI
          MOV   FS,BP

          FLD   DS:[EBX.VECTOR_X]      ; \u.x
          FMUL  PD ES:[EDX]            ; \u.x * t
          FSTP  FS:[ECX.VECTOR_X]      ; \---

          FLD   DS:[EBX.VECTOR_Y]      ; \u.y
          FMUL  PD ES:[EDX]            ; \u.y * t
          FSTP  FS:[ECX.VECTOR_Y]      ; \---

          FLD   DS:[EBX.VECTOR_Z]      ; \u.z
          FMUL  PD ES:[EDX]            ; \u.z * t
          FSTP  FS:[ECX.VECTOR_Z]      ; \---

          POP   FS ES DS
          RET
vectmuln ENDP


;  ᫥饥 ᥢ砩 ᫮.
; 室 : ।饥 ᥢ砩 ᫮ (  BX).
; 室: ᫥饥 ᥢ砩 ᫮ (  BX);
;        ॣ AX,CX,DX 㬯.
random16 PROC NEAR
          MOV   DX,1
          XOR   AL,AL
          ADD   BX,DX
          ADC   AL,DH

          MOV   CX,BX
          MOV   DL,AL
          ADD   BX,BX
          ROL   AL,1
          ADD   BX,BX
          ROL   AL,1
          ADD   BX,BX
          ROL   AL,1
          ADD   BX,BX
          ROL   AL,1
          SBB   BX,CX
          SBB   AL,DL

          MOV   CX,BX
          MOV   DL,AL
          ADD   BX,BX
          ROL   AL,1
          ADD   BX,BX
          ROL   AL,1
          ADD   BX,CX
          ADC   AL,DL
          MOV   DL,AL
          SBB   BX,DX
          MOV   DL,DH
          CMC
          SBB   BX,DX
          RET
random16 ENDP
