
SUBTTL "Private coding procedure for Fwcs Population Game."


ASSUME   DS:DATA,ES:NOTHING,FS:NOTHING,GS:NOTHING


; 頥  BX,DX,SI,DI אַ㣮쭨,
;   ஬  ᬠਢ .
; 室: BX,DX,SI,DI - ⥪  ࠧ.
FiMinMax PROC NEAR
          PUSHA
COMMENT `
          MOV   AX,SI
          MOV   BP,DI
          MOV   SI,BX
          MOV   DI,DX
    ;  !!!
`
          POPA
          RET
FiMinMax ENDP


; ᫨  CH   ࠢ  GRAY_V  㢥稢  CL   .
IncCLnoF PROC NEAR
          CMP   CH,clGRAY_V
          JE    @@p1
          INC   CL
@@p1 :    RET
IncCLnoF ENDP


; 頥  (CH)  ᮡ (BX,DX).
WhoWhere PROC NEAR
          PUSH  AX EBX DX EBP

    ; ᫥ (BX-BegX)+(DX-BegY)*(EndX-BegX+1)+4.
          ADD   BX,4
          SUB   BX,[Spc_BegX]      ; BX=BX-BegX+4
          MOV   AX,DX
          SUB   AX,[Spc_BegY]      ; AX=DX-BegY
          MUL   [PW ES:0]          ; DX:AX=(DX-BegY)*SizeX
          MOV   BP,DX
          SHL   EBP,16
          MOV   BP,AX
          MOVZX EBX,BX
          ADD   EBP,EBX            ; EBP=(BX-BegX)+(DX-BegY)*(SizeX)+4

          MOV   CH,ES:[EBP]        ; CH=status(BX,DX)
          POP   EBP DX EBX AX
          RET
WhoWhere ENDP


; 頥  (CH)  ᮡ (BX,DX).
; ᫨  CH   ࠢ  GRAY_F  㢥稢  CL   .
WhoPosit PROC NEAR
          CALL  WhoWhere
          CALL  IncCLnoF           ; ᫨  GRAY_F,  CL=CL+1
          RET
WhoPosit ENDP


; 頥 ⢮ (CL) ᮡ   (BX,DX).
;  (CH) 頥  ⥪饩 (BX,DX) ᮡ.
; 室: [DS:Spc_????] - ⥪  ࠧ.
ScAround PROC NEAR
          XOR   CL,CL

          DEC   BX
          DEC   DX
          CALL  WhoPosit
          INC   BX
          CALL  WhoPosit
          INC   BX
          CALL  WhoPosit

          INC   DX
          CALL  WhoPosit
          SUB   BX,2
          CALL  WhoPosit

          INC   DX
          CALL  WhoPosit
          INC   BX
          CALL  WhoPosit
          INC   BX
          CALL  WhoPosit

          DEC   BX
          DEC   DX
          CALL  WhoWhere
          RET
ScAround ENDP


; ந  蠣 ࠧ.
; 室: [DS:Spc_????] - ⥪  ࠧ.
OneStep  PROC NEAR
          PUSHA
          PUSH  ECX
          XOR   ECX,ECX            ; ⠫ 
          MOV   AX,iGetBoxWn       ;  ⥫ 
          INT   INTfcScr           ;   .

          MOV   DX,[Spc_BegY]
          INC   DX
@@l2 :    MOV   BX,[Spc_BegX]
          INC   BX

@@l1 :    CALL  ScAround
          CMP   CL,2
          JE    @@sc2
          CMP   CL,3
          JE    @@sc3
          MOV   CH,clGRAY_V
          JMP   @@q1

@@sc2 :   CMP   CH,clGRAY_V
          JE    @@q2
          INC   CH
          JMP   @@q1

@@sc3 :   CMP   CH,clGRAY_V
          JE    @@new
          CMP   CH,clGRAY_0
          JE    @@q1
          DEC   CH
          JMP   @@q1
@@new :   MOV   CH,clGRAY_0

@@q1 :    MOV   AX,iSetPixWn
          INT   INTfcScr
@@q2 :    INC   BX
          CMP   BX,[Spc_EndX]
          JL    @@l1
          INC   DX
          CMP   DX,[Spc_EndY]
          JL    @@l2

          POP   ECX
          POPA
          RET
OneStep  ENDP


; 砫  .
StartGam PROC NEAR
          PUSHAD
          MOV   AX,iResMouse
          INT   INTfcMou
          MOV   CX,SEGfpgDT        ;  ᪨
          MOV   DS,CX              ;   ਫ.
          MOV   CX,SEGfpgPO        ;   
          MOV   ES,CX              ;  ।饩 樨.

          MOV   AX,iGtAcSize       ;   (BX,DX) -   
          INT   INTfcWnd           ;  ⨢  .
          MOV   SI,BX
          XOR   BX,BX              ;   BX,DX,SI,DI
          DEC   SI                 ;  - ࠭ ⥪饩
          MOV   DI,DX              ;   ࠧ
          XOR   DX,DX              ;   न
          DEC   DI                 ;  ⨢ .
          CALL  FiMinMax           ; BX,DX,SI,DI -  樨.
          MOV   [Spc_BegX],BX
          MOV   [Spc_BegY],DX      ; ࠭
          MOV   [Spc_EndX],SI      ;  ࠭ 樨
          MOV   [Spc_EndY],DI      ;    ६ FPG.

          CALL  OneStep            ;   蠣 ࠡ⪨.
@@agane : MOV   AX,iKeyReadP
          INT   INTfcKey
          CMP   AL,'0'
          JL    @@quit
          JE    @@zero
          CMP   AL,'9'
          JG    @@quit
          SUB   AL,'0'
          MOVZX CX,AL
@@l1 :    CALL  OneStep
          LOOP  @@l1
          JMP   @@agane

@@zero :  CALL  OneStep
          MOV   AX,iKeyPress
          INT   INTfcKey
          OR    AL,AL
          JZ    @@zero
          JMP   @@agane

@@quit :  MOV   AX,iSetMouse
          INT   INTfcMou
          POPAD
          RET
StartGam ENDP
