
SUBTTL "Private coding procedure for Fwcs Tetris Game."

ASSUME   DS:DATA,ES:NOTHING,FS:NOTHING,GS:NOTHING


;  窮.
; 室 : AX - 稭 (ASCII),   㦭 㢥 .
SetScore PROC NEAR
          PUSHA
          ADD  AL,[ScrData+4]
          AAA
          ADD  AL,'0'
          MOV  [ScrData+4],AL

          MOV  AL,AH
          MOV  AH,000h
          ADD  AL,[ScrData+3]
          AAA
          ADD  AL,'0'
          MOV  [ScrData+3],AL

          MOV  AL,AH
          MOV  AH,000h
          ADD  AL,[ScrData+2]
          AAA
          ADD  AL,'0'
          MOV  [ScrData+2],AL

          MOV  AL,AH
          MOV  AH,000h
          ADD  AL,[ScrData+1]
          AAA
          ADD  AL,'0'
          MOV  [ScrData+1],AL

          MOV  AL,AH
          MOV  AH,000h
          ADD  AL,[ScrData]
          AAA
          ADD  AL,'0'
          MOV  [ScrData],AL

          CMP  AL,[RecData]
          JC   PrnScore
          JNZ  NewRec
          MOV  AX,[PW ScrData+1]

          CMP  AL,[RecData+1]
          JC   PrnScore
          JNZ  NewRec
          MOV  AX,[PW ScrData+2]

          CMP  AL,[RecData+2]
          JC   PrnScore
          JNZ  NewRec
          MOV  AX,[PW ScrData+3]

          CMP  AL,[RecData+3]
          JC   PrnScore
          JNZ  NewRec
          CMP  AH,[RecData+4]
          JNA  PrnScore

NewRec :  MOV  AX,[PW ScrData+3]
          MOV  [PW RecData+3],AX
          MOV  AX,[PW ScrData+1]
          MOV  [PW RecData+1],AX
          MOV  AL,[ScrData]
          MOV  [RecData],AL
          MOV  [RecChFlg],1

PrnScore: MOV   AX,SEGftgED
          MOV   ES,AX
          MOV   EBP,AWC+W_FTG*WINOBJLN
          MOV   BX,ES:[EBP.TxBegX]
          MOV   DX,ES:[EBP.TxBegY]
          ADD   BX,11*8-6
          ADD   DX,9*12-1
          MOV   SI,10
          MOV   DI,5

          MOV   CX,DS
          MOV   EBP,OFFSET ScrData
          MOV   AX,iPrn5Symb
          INT   INTfcTxt
          ADD   DX,14
          MOV   EBP,OFFSET RecData
          MOV   AX,iPrn5Symb
          INT   INTfcTxt

          POPA
          RET
SetScore ENDP


; ᮢ ᫥饩 䨣 (  ।⥫쭮 ᬮ).
DrawNext PROC NEAR
          PUSHA

    ; ᮢ 䮭 אַ㣮쭨 (࠭ ।饩 䨣).
          MOV   BX,3*8+4
          MOV   DX,13*12+4
          MOV   SI,[ScaleX]
          ADD   SI,SI
          MOV   DI,SI
          ADD   SI,SI
          ADD   SI,DI
          ADD   SI,BX
          MOV   DI,[ScaleY]
          SHL   DI,2
          ADD   DI,DX
          MOV   CH,clBLACK
          MOV   AX,iSetBoxWn
          INT   INTfcScr

    ;  ᫥饩 䨣.
          MOV   BX,[RandSeed]
          MOV   AX,iRandom16
          INT   INTfcMat
          MOV   AX,BX
          XOR   DX,DX
          MOV   BX,SCOREFIG
          DIV   BX
          MOV   BX,DX
          SHL   BX,2                    ; 4*INT(7*RND)

    ;  横 ᮢ.
          MOV   AX,[PW FigsData+BX]
          MOV   BX,3*8+4+16
          MOV   DX,13*12+4+16
          MOV   DI,[ScaleY]
          ADD   DI,DX
          MOV   BP,BX
          DEC   DI

    ; ᮢ ᫥饩 䨣.
          MOV   CH,2
@@loop1 : MOV   CL,4
          MOV   BX,BP
          MOV   SI,[ScaleX]
          ADD   SI,BX
          DEC   SI
@@loop2 : ADD   AH,AH
          PUSH  AX CX
          JNC   @@no_pr
          MOV   CH,AL
          MOV   AX,iSetBoxWn
          INT   INTfcScr
@@no_pr : POP   CX AX
          ADD   BX,[ScaleX]
          ADD   SI,[ScaleX]
          DEC   CL
          JNZ   @@loop2
          ADD   DX,[ScaleY]
          ADD   DI,[ScaleY]
          DEC   CH
          JNZ   @@loop1

          POPA
          RET
DrawNext ENDP


; 뢮 ⠪  ࠭.
ScrnSet  PROC NEAR
          PUSHA
          MOV   AX,iSetBoxWn
          MOV   BP,OFFSET GameData

          MOV   DX,[BegGlasY]
          MOV   CX,[SizeSpcY]
@@ly :    PUSH  CX
          MOV   BX,[BegGlasX]
          MOV   CX,[SizeSpcX]
@@lx :    PUSH  CX

          MOV   SI,BX
          ADD   SI,[ScaleX]
          DEC   SI
          MOV   DI,DX
          ADD   DI,[ScaleY]
          DEC   DI

          MOV   CH,DS:[BP]
          TEST  CH,CH
          JNS   @@clok
          AND   CH,03Fh
          MOV   DS:[BP],PB 0
@@clok :  INT   INTfcScr

          INC   BP
          ADD   BX,[ScaleX]
          POP   CX
          DEC   CX
          JNZ   @@lx
          ADD   DX,[ScaleY]
          POP   CX
          DEC   CX
          JNZ   @@ly

          POPA
          RET
ScrnSet  ENDP


;  䨣  ⠪  ஢મ  ⮩ .
; 室 : AL - 梥 䨣.
;        AH - ଠ (⮢ ).
FigurSet  PROC NEAR
          MOV   BX,AX                  ; ࠭   䨣.

          MOV   AL,[FigCoorY]          ; ᫥ 
          MOV   AH,[PB SizeSpcX]       ;  業 䨣
          MUL   AH                     ;   ᨢ
          ADD   AL,[FigCoorX]          ;   
          ADC   AH,000h                ;  (.. 
          XCHG  AX,BX                  ;   ⠪).
          TEST  [FigCoorL],001h        ;  ᨬ  ⥪饣 㣫
          JNZ   @@vert                 ;   䨣 㤥 
          TEST  [FigCoorL],002h        ;   ࠧ, ..  ࠧ묨
          JNZ   @@horrear              ;  饭ﬨ न.

          SUB   BX,[SizeSpcX]          ; 砩,
          DEC   BX                     ;  
          MOV   SI,1                   ;  䨣
          MOV   DI,8                   ;  
          JMP   @@stset                ;  .

@@horrear:ADD   BX,002h                ; 
          CMP   [FigCrctY],000h        ;  
          JE    @@hrcyo                ;  
          ADD   BX,[SizeSpcX]          ;  180
@@hrcyo : SUB   BL,[FigCrctX]          ;  ࠤᮢ.
          SBB   BH,000h                ;
          MOV   SI,-1                  ;
          MOV   DI,-8                  ;
          JMP   @@stset                ;

@@vert :  TEST  [FigCoorL],002h        ;
          JNZ   @@vrtrear              ;
          SUB   BX,[SizeSpcX]          ; 
          SUB   BX,[SizeSpcX]          ;  
          INC   BX                     ;  
          CMP   [FigCrctX],000h        ;  90
          JE    @@vfcxo                ;  ࠤᮢ.
          ADD   BX,[SizeSpcX]          ;
@@vfcxo : MOV   SI,[SizeSpcX]          ;
          MOV   DI,-1                  ;
          SUB   DI,SI                  ;
          SUB   DI,SI                  ;
          SUB   DI,SI                  ;
          SUB   DI,SI                  ;
          JMP   @@stset                ;

@@vrtrear:ADD   BX,[SizeSpcX]          ; 
          SUB   BL,[FigCrctY]          ;  
          SBB   BH,000h                ;  
          MOV   SI,[SizeSpcX]          ;  270
          MOV   DI,SI                  ;  ࠤᮢ
          NEG   SI                     ;
          SHL   DI,2                   ;
          ADD   DI,1                   ;

    ; 뢮 䨣  ।⥫쭮 ஢મ  ⠪ 뢮.
@@stset : MOV   CL,002h                ; 稪  䨣.
@@cicmain:MOV   CH,004h                ; 稪   .
@@cicline:ADD   AH,AH                  ; ६饭 ࠢ  蠡
          JNC   @@point                ;   CF. ᫨  , 室.
          CMP   [GameData+BX],000h     ; ஢ઠ  ⥪饩 䨣
          JNE   @@clfig                ;   㦥  . ⬥.
          MOV   [GameData+BX],AL       ;  . 믮.

@@point : ADD   BX,SI                  ; 室  ᫥饬  :
          DEC   CH                     ;  ᫮  ⥪饩
          JNZ   @@cicline              ;  樨  饭.
          ADD   BX,DI                  ; 室  ᫥饩  䨣:
          DEC   CL                     ;  ᫮  ⥪饩
          JNZ   @@cicmain              ;  樨  饭.
          CLC                          ; 室  ਧ ᯥ譮
          RET                          ;  襭  䨣.

    ; 訡 .  䨣  ⠪.
@@clfig : MOV   SI,OFFSET GameData     ; 砫 ⠪.
          PUSH  AX                     ;
          MOV   AH,[PB SizeSpcX]       ;
          MOV   AL,[PB SizeSpcY]       ;
          DEC   AL                     ;
          MUL   AH                     ;
          MOV   CX,AX                  ;  ⠪.
          POP   AX                     ;

@@ciclear:CMP   [SI],PB 080h           ; ᫨ 
          JC    @@po                   ;  ६,
          MOV   [SI],PB 000h           ;  㤠塞.
@@po :    INC   SI                     ; 騩
          LOOP  @@ciclear              ;  .

          STC                          ; 室  ਧ 㤠
          RET                          ;   ⥪饩 䨣.
FigurSet ENDP


;    蠣 :
;  ⠭   䨣;
;  ९ 㯠襩 䨣;
;  㤠  ;
;  ᮧ  䨣.
; 室: CF=1 - ⠪ , ..     䨣.
NewPosit PROC NEAR
          CMP   [PB FigData],000h      ; ᫨  䨣 㦥
          JNE   @@OldFig               ;  , 室.

    ; ⠭  䨣.
          MOV   BX,[RandSeed]
          MOV   AX,iRandom16
          INT   INTfcMat
          MOV   AX,BX
          MOV   [RandSeed],AX
          XOR   DX,DX
          MOV   BX,SCOREFIG
          DIV   BX
          MOV   BX,DX
          SHL   BX,2                    ; 4*INT(7*RND)

          MOV   AX,[PW FigsData+BX]
          MOV   BX,[PW FigsData+BX+2]

          MOV   [FigData],AX
          OR    AL,080h
          MOV   [FigCrct],BX

          MOV   [FigCoorX],005h       ; ⠭
          MOV   [FigCoorY],001h       ;  ⥪
          MOV   [FigCoorL],000h       ;  न.

          CALL  DrawNext
          JMP   FigurSet

    ; ६饭 䨣, ᮧ ࠭.
@@OldFig: CMP   [SpeedCnt],001h
          JNE   @@cyo

          INC   [FigCoorY]

          MOV   AX,[FigData]
          OR    AL,080h
          CALL  FigurSet
          JNC   @@ret2

          DEC   [FigCoorY]

          MOV   AX,[FigData]
          CALL  FigurSet

          MOV   AX,00001h
          CALL  SetScore

          MOV   [BYTE PTR FigData],000h

          MOV   SI,OFFSET GameData+1
          MOV   AH,[PB SizeSpcY]
          DEC   AH

@@ct :    MOV   CX,[SizeSpcX]
          SUB   CX,2

@@ctl :   CMP   [SI],PB 000h
          JE    @@nl
          INC   SI
          LOOP  @@ctl

          PUSH  SI
          MOV   BX,SI
          SUB   BX,[SizeSpcX]
          MOV   CX,BX
          SUB   CX,OFFSET GameData+1

@@cdl :   MOV   AL,[BX]
          MOV   [SI],AL
          DEC   BX
          DEC   SI
          LOOP  @@cdl

          PUSH  AX
          MOV   AX,00200h
          CALL  SetScore
          POP   AX
          POP   SI

@@nl :    ADD   SI,002h
          ADD   SI,CX
          DEC   AH
          JNZ   @@ct
          CLC
@@ret2 :  RET

    ; ६饭 䨣 -ࠢ  .
@@cyo :   MOV   AL,[FigCoorL]
          MOV   [FigCrdLR],AL
          MOV   BL,[KeySymb]      ;ADD   AL,[UpPress]    ;SUB
          CMP   BL,01Eh
          SETz  BL
          ADD   AL,BL
          AND   AL,003h
          MOV   [FigCoorL],AL

          MOV   AL,[FigCoorX]
          MOV   [FigCrdXR],AL

          MOV   BL,[KeySymb]      ;ADD   AL,[RtPress]
          CMP   BL,010h
          SETz  BL
          ADD   AL,BL
          MOV   BL,[KeySymb]      ;ADD   AL,[LfPress]
          CMP   BL,011h
          SETz  BL
          SUB   AL,BL
          MOV   [FigCoorX],AL

          MOV   AX,[FigData]
          OR    AL,080h
          CALL  FigurSet

          JNC   @@ret2
          MOV   AL,[FigCrdLR]
          CMP   AL,[FigCoorL]
          JE    @@clo
          MOV   [FigCoorL],AL

          MOV   AX,[FigData]
          OR    AL,080h
          CALL  FigurSet
          JNC   @@ret2
@@clo :   MOV   AL,[FigCrdXR]
          MOV   [FigCoorX],AL
          MOV   AX,[FigData]
          OR    AL,080h
          CALL  FigurSet
          RET
NewPosit ENDP


; 砫  .
StartGam PROC NEAR
          CALL  InitGame               ; 樠 .

    ; த .
ContGame: MOV   AX,SEGftgDT            ;  ᪨
          MOV   DS,AX                  ;   ਫ.

          MOV   AX,iResMouse           ; ⠫
          INT   INTfcMou               ;  㪠⥫ .
          XOR   AX,AX                  ; 
          CALL  SetScore               ;  窮.

@@LoopMn: DEC   [SpeedCnt]             ; 襭 稪
          JNZ   @@so                   ;  ᪮ ,
          MOV   AL,[SpeedGam]          ;  ᫨ =0, ⠭
          MOV   [SpeedCnt],AL          ;   祭.

@@so :    MOV   [TimeCnt],002h         ; ஭  ॠ ६.

          MOV   [KeySymb],0
          MOV   AX,iKeyPress
          INT   INTfcKey
          OR    AL,AL
          JZ    @@nosmb
          MOV   AX,iKeyReadP
          INT   INTfcKey
          MOV   [KeySymb],AL
          MOV   AX,iKeyClear
          INT   INTfcKey

@@nosmb : CALL  NewPosit               ;   ⥪饬 蠣 .
          JC    @@GamOvr               ; ᫨   .
          CALL  ScrnSet                ; 뢮  ࠭ ⠪.

          MOV   AL,[KeySymb]
          CMP   AL,01Fh                ; [DOWN]
          JNE   @@cw
          MOV   [SpeedCnt],002h        ;

@@cw :    INT   INTfcTSV
          CALL  GamTimer               ;
          CMP   [TimeCnt],000h         ;
          JNE   @@cw                   ;

          MOV   AL,[KeySymb]
          CMP   AL,01Bh                ; [ESC]
          JE    @@quit

          JMP   @@LoopMn

    ;  .
@@GamOvr: CALL  InitGame               ; 樠 .

    ;  "Game Over".
          MOV   AX,SEGftgED
          MOV   DS,AX
          MOV   EBX,AWC+W_OVER*WINOBJLN
          MOV   AX,iWindow
          INT   INTfcWnd

@@quit :  MOV   AX,iSetMouse           ; 
          INT   INTfcMou               ;  㪠⥫ .
@@end :   RET
StartGam ENDP


; 樠 .
InitGame PROC NEAR
          PUSH  AX BX CX
          MOV   AX,SEGftgDT            ;  ᪨
          MOV   DS,AX                  ;   ਫ.

    ; ⪠ ஢  ("⠪").
          MOV   BX,OFFSET GameData+1
          MOV   CH,[PB SizeSpcY]
          DEC   CH
@@cc :    MOV   CL,[PB SizeSpcX]
          SUB   CL,2
@@ccl :   MOV   [BX],PB 0
          INC   BX
          DEC   CL
          JNZ   @@ccl
          ADD   BX,002h
          DEC   CH
          JNZ   @@cc

          MOV   [PW ScrData],"00"      ; 㫥
          MOV   [PW ScrData+2],"00"    ;  ⥪
          MOV   [ScrData+4],'0'        ;  窮.

          MOV   [FigData],PB 000h      ;  ⥪饩 䨣.

          MOV   AL,[SpeedGam]          ; 樠 ᪮
          MOV   [SpeedCnt],AL          ;   (  2).

          POP   CX BX AX
          RET
InitGame ENDP


;   TimeCnt.
GamTimer PROC NEAR
          PUSH  EAX EBX
          MOV   AX,iGetTimFC           ; ஢ઠ 쭮
          INT   INTfcBas               ;  稪 FCOS.
          MOV   EAX,EBX                ; ᫨   ,
          SUB   EBX,[OldTimer]         ;   ࠧ 室,
          JZ    @@quit                 ;   
          MOV   [OldTimer],EAX         ;  稪 ᨭ஭樨.
          SUB   [TimeCnt],1            ; 襭 稪
          ADC   [TimeCnt],0            ;    ⥫쭮.
@@quit :  POP   EBX EAX
          RET
GamTimer ENDP
