
SUBTTL "  ᥫ FVR."

; c_Color  // ८ࠧ  [SI:EBX]  RGB- [DI:ECX].
; DrawPixl // 室: [SI:ECX] - RGB 窨  . (BX,DX).
; OpnTarga // ⨥ 䠩 TGA   ⥪饩 業.
; CloTarga // ⨥ 䠩 TGA   ⥪饩 業.
; FlushTGA //    .
; PutPxTGA // 頥  ᥫ  䠩 TGA  (梥  [SI:ECX]).


; ८ࠧ  [SI:EBX]  RGB- [DI:ECX].
; 室: DS:SEGfvrDT.
c_Color  PROC NEAR
          PUSH  AX EBP ES FS
          MOV   FS,SI
          MOV   ES,DI
          SUB   ESP,2                  ;    ६.
          MOV   EBP,ESP                ; [ESP]=&temp_c.

          FLD   FS:[EBX.VECTOR_X]      ; \Color.x
          FMUL  [const255]             ; \255*Color.x
          FISTP PW SS:[EBP]            ; temp_c=255*Color.x  \--
          MOV   AL,PB SS:[EBP]         ;
          MOV   ES:[ECX.RGB_RED],AL    ; c.Red=Lo(temp_c)

          FLD   FS:[EBX.VECTOR_Y]
          FMUL  [const255]
          FISTP PW SS:[EBP]
          MOV   AL,PB SS:[EBP]
          MOV   ES:[ECX.RGB_GRN],AL

          FLD   FS:[EBX.VECTOR_Z]
          FMUL  [const255]
          FISTP PW SS:[EBP]
          MOV   AL,PB SS:[EBP]
          MOV   ES:[ECX.RGB_BLU],AL

          ADD   ESP,2
          POP   FS ES EBP AX
          RET
c_Color  ENDP


; ⠢ ⥪ .
; 室: [SI:ECX] - RGB 窨  . (BX,DX).
; 室:  ॣ ࠭.
DrawPixl PROC NEAR
          PUSH  AX CX EBP ES  BX DX
          MOV   ES,SI
          MOV   EBP,ECX

          MOV   BL,51
          XOR   AH,AH
          MOV   AL,ES:[EBP.RGB_RED]
          DIV   BL
          CMP   AH,26
          JL    @@p1
          INC   AL
@@p1 :    MOV   CH,AL
          XOR   AH,AH
          MOV   AL,ES:[EBP.RGB_GRN]
          DIV   BL
          CMP   AH,26
          JL    @@p2
          INC   AL
@@p2 :    XOR   AH,AH
          IMUL  AX,6
          ADD   CH,AL
          XOR   AH,AH
          MOV   AL,ES:[EBP.RGB_BLU]
          DIV   BL
          CMP   AH,26
          JL    @@p3
          INC   AL
@@p3 :    XOR   AH,AH
          IMUL  AX,36
          ADD   CH,AL
          ADD   CH,32

          POP   DX BX
          MOV   AX,iSetPixWn
          INT   INTfcScr
          POP   ES EBP CX AX
          RET
DrawPixl ENDP


; ⨥ 䠩 TGA   ⥪饩 業.
; 室: DS:SEGfvrDT.
; 室:  ॣ ࠭.
OpnTarga PROC NEAR
          PUSH  AX EBX CX EDX BP SI DI

          MOV   DI,SEGfvrDT
          MOV   EDX,OFFSET TGAexamp
          MOV   AX,iCreatFil
          INT   INTfcDsk
          MOV   [TGAhandl],BP

          MOV   AX,[nx]
          MOV   [TGAheadr.TGAx_len],AX
          MOV   AX,[ny]
          MOV   [TGAheadr.TGAy_len],AX
          MOV   SI,DI
          MOV   EBX,OFFSET TGAheadr
          MOV   CX,18
          MOV   AX,i_SvSmlBl
          INT   INTfcDsk               ;  ⪠ 䠩.

          MOV   [PrtTarga],0
          POP   DI SI BP EDX CX EBX AX
          RET
OpnTarga ENDP


; ⨥ 䠩 TGA   ⥪饩 業.
; 室: DS:SEGfvrDT.
; 室:  ॣ ࠭.
CloTarga PROC NEAR
          PUSH  AX BP
          CALL  FlushTGA

          MOV   BP,[TGAhandl]
          MOV   AX,iCloseFil
          INT   INTfcDsk

          POP   BP AX
          RET
CloTarga ENDP


;    .
; 室: DS:SEGfvrDT.
; 室:  ॣ ࠭.
FlushTGA PROC NEAR
          PUSH  AX EBX CX SI BP

          MOV   CX,[PrtTarga]
          OR    CX,CX
          JZ    @@p1
          MOV   [PrtTarga],0

          MOV   SI,SEGfvrED
          MOV   EBX,OFFSET BufTarga
          MOV   BP,[TGAhandl]
          MOV   AX,i_SvSmlBl
          INT   INTfcDsk

@@p1 :    POP   BP SI CX EBX AX
          RET
FlushTGA ENDP


; 頥  ᥫ  䠩 TGA  (梥  [SI:ECX]).
; 室: DS:SEGfvrDT.
; 室:  ॣ ࠭.
PutPxTGA PROC NEAR
          PUSH  AX EBX CX EBP ES FS
          MOV   AX,SEGfvrED
          MOV   ES,AX
          MOV   EBP,ECX
          MOV   FS,SI

          MOV   CX,[PrtTarga]
          CMP   CX,LENbfTGA
          JL    @@p1
          CALL  FlushTGA

@@p1 :    MOVZX EBX,PW [PrtTarga]
          ADD   EBX,OFFSET BufTarga
          MOV   AX,PW FS:[EBP]
          XCHG  AL,AH
          MOV   ES:[EBX+1],AX
          MOV   AL,PB FS:[EBP+2]
          MOV   ES:[EBX],AL
          ADD   [PrtTarga],3

          POP   FS ES EBP CX EBX AX
          RET
PutPxTGA ENDP
