
SUBTTL "Private coding procedure for HSV\scr."


;              .


; ⠭ 窨  (BX,DX,CH).
SetPix   PROC FAR
          PUSH  AX
          MOV   AX,iStPixGfx
          INT   INTfcGfx
          POP   AX
          RET
SetPix   ENDP


; । 梥 窨 :  CH=WhoPix(BX,DX).
WhoPix   PROC FAR
          PUSH  AX
          MOV   AX,iWhPixGfx
          INT   INTfcGfx
          POP   AX
          RET
WhoPix   ENDP


; ᮢ   (BX,DX,SI,DI,CH).
SetLin   PROC FAR
          PUSH  AX
          MOV   AX,iStLinGfx
          INT   INTfcGfx
          POP   AX
          RET
SetLin   ENDP


; 襭 אַ㣮쭨 (BX,DX,SI,DI,CH).
SetBox   PROC FAR
          PUSH  AX
          MOV   AX,iStBoxGfx
          INT   INTfcGfx
          POP   AX
          RET
SetBox   ENDP


;  אַ㣮쭨   :  PutBox(BX,DX, ES:ECX).
PutBox   PROC FAR
          PUSH  AX
          MOV   AX,iPtBoxGfx
          INT   INTfcGfx
          POP   AX
          RET
PutBox   ENDP


; ࠭ אַ㣮쭨   :  GetBox(BX,DX,SI,DI, ES:ECX).
GetBox   PROC FAR
          PUSH  AX
          MOV   AX,iGtBoxGfx
          INT   INTfcGfx
          POP   AX
          RET
GetBox   ENDP


;  אַ㣮쭨  (BX,DX,SI,DI,CH).
SetRct   PROC FAR
          PUSH  AX
          MOV   AX,iStRctGfx
          INT   INTfcGfx
          POP   AX
          RET
SetRct   ENDP


;  אַ㣮쭨    ⮬
;  ஧筮 祪 ( 255=0FFh) :  PprBox(BX,DX,ES:ECX).
PprBox   PROC FAR
          PUSH  AX
          MOV   AX,iPrBoxGfx
          INT   INTfcGfx
          POP   AX
          RET
PprBox   ENDP


; ࠭  אַ㣮쭨   :  GetRct(BX,DX,SI,DI, ES:ECX).
GetRct   PROC FAR
          PUSH  AX
          MOV   AX,iGtRctGfx
          INT   INTfcGfx
          POP   AX
          RET
GetRct   ENDP


;   אַ㣮쭨   :  PutBox(BX,DX, ES:ECX).
PutRct   PROC FAR
          PUSH  AX
          MOV   AX,iPtRctGfx
          INT   INTfcGfx
          POP   AX
          RET
PutRct   ENDP


; 楤 ந 㦭  業஬  (BX,DX),
;  ࠤᮬ  DI, 梥⮬  CH.
SetCir   PROC FAR
          PUSH  AX
          MOV   AX,iStCirGfx
          INT   INTfcGfx
          POP   AX
          RET
SetCir   ENDP


;                               .


;  梥⮢  (16x16)x(16x16)x(256).
; 室 : BX,DX - न 孥  㣫.
DrwGamma PROC FAR
          PUSHA
          XOR   AX,AX                  ; 稭  㫥 梥.

@@p1 :    MOV   BX,AX                  ; ⠫
          AND   BX,00001111b           ;  ਧ⠫
          SHL   BX,4                   ;  न.
          ADD   BX,SS:[ESP+8]          ;
          MOV   DX,AX                  ; ⠫
          AND   DX,11110000b           ;  ⨪
          ADD   DX,SS:[ESP+10]         ;  न.

          MOV   SI,BX                  ; ⠫
          ADD   SI,15                  ;  ࠢ
          MOV   DI,DX                  ;  
          ADD   DI,15                  ;  㣮.

          MOV   CH,AL                  ; ᮢ
          PUSH  AX                     ;  襭
          MOV   AX,iSetBoxWn           ;  אַ㣮쭨
          INT   INTfcScr               ;  ⥪饣
          POP   AX                     ;  梥.
          INC   AX                     ;
          CMP   AX,256                 ; 騩
          JL    @@p1                   ;  梥.

          POPA
          RET
DrwGamma ENDP


; ⠭ 窨 (BX,DX,CH)  ⥪饬 .
SetPixWn PROC FAR
          PUSH  AX EBX DX EBP DS
          MOV   EBP,EBX
          MOV   AX,iGetAdrCA           ;  (DS:EBX) -  
          INT   INTfcWnd               ;   ⥪饣 .
          XCHG  EBX,EBP

          ADD   BX,DS:[EBP.TxBegX]     ;  ᮫ न
          ADD   DX,DS:[EBP.TxBegY]     ;   ⥪饣 .
          MOV   AX,iStPixGfx           ; ⠢
          INT   INTfcGfx               ;  .
          POP   DS EBP DX EBX AX
          RET
SetPixWn ENDP


; । 梥 窨 : CH=WhoPixWn(BX,DX)   ⥪饬 .
WhoPixWn PROC FAR
          PUSH  AX EBX DX EBP DS
          MOV   EBP,EBX
          MOV   AX,iGetAdrCA           ;  (DS:EBX) -  
          INT   INTfcWnd               ;   ⥪饣 .
          XCHG  EBX,EBP

          ADD   BX,DS:[EBP.TxBegX]     ;  ᮫ न
          ADD   DX,DS:[EBP.TxBegY]     ;   ⥪饣 .
          MOV   AX,iWhPixGfx           ; ।
          INT   INTfcGfx               ;  梥 窨.
          POP   DS EBP DX EBX AX
          RET
WhoPixWn ENDP


; ᮢ   (BX,DX,SI,DI,CH)   ⥪饬 .
SetLinWn PROC FAR
          PUSHAD
          PUSH  DS
          MOV   EBP,EBX
          MOV   AX,iGetAdrCA           ;  (DS:EBX) -  
          INT   INTfcWnd               ;   ⥪饣 .
          XCHG  EBX,EBP

          MOV   AX,DS:[EBP.TxBegX]     ;  ᮫ न
          MOV   BP,DS:[EBP.TxBegY]     ;   ⥪饣 .
          ADD   BX,AX                  ; 
          ADD   SI,AX                  ;  ᮫
          ADD   DX,BP                  ;  न 
          ADD   DI,BP                  ;  ⥪饣 .

          MOV   AX,iStLinGfx           ; ᮢ
          INT   INTfcGfx               ;  .
          POP   DS
          POPAD
          RET
SetLinWn ENDP


; 襭 אַ㣮쭨 (BX,DX,SI,DI,CH)   ⥪饬 .
SetBoxWn PROC FAR
          PUSHAD
          PUSH  DS
          MOV   EBP,EBX
          MOV   AX,iGetAdrCA           ;  (DS:EBX) -  
          INT   INTfcWnd               ;   ⥪饣 .
          XCHG  EBX,EBP

          MOV   AX,DS:[EBP.TxBegX]     ;  ᮫ न
          MOV   BP,DS:[EBP.TxBegY]     ;   ⥪饣 .
          ADD   BX,AX                  ; 
          ADD   SI,AX                  ;  ᮫
          ADD   DX,BP                  ;  न 
          ADD   DI,BP                  ;  ⥪饣 .

          MOV   AX,iStBoxGfx           ; 
          INT   INTfcGfx               ;  אַ㣮쭨.
          POP   DS
          POPAD
          RET
SetBoxWn ENDP


; ࠭  ⨢  : GetBoxWn(BX,DX,SI,DI; ES,ECX).
GetBoxWn PROC FAR
          PUSHAD
          PUSH  DS
          MOV   EBP,EBX
          MOV   AX,iGetAdrCA           ;  (DS:EBX) -  
          INT   INTfcWnd               ;   ⥪饣 .
          XCHG  EBX,EBP

          MOV   AX,DS:[EBP.TxBegX]     ;  ᮫ न
          MOV   BP,DS:[EBP.TxBegY]     ;   ⥪饣 .
          ADD   BX,AX                  ; 
          ADD   SI,AX                  ;  ᮫
          ADD   DX,BP                  ;  न 
          ADD   DI,BP                  ;  ⥪饣 .

          MOV   AX,iGtBoxGfx           ; ࠭
          INT   INTfcGfx               ;  .
          POP   DS
          POPAD
          RET
GetBoxWn ENDP


;   ࠭   :  PutBox(BX,DX, ES:ECX).
PutBoxWn PROC FAR
          PUSHAD
          PUSH  DS
          MOV   EBP,EBX
          MOV   AX,iGetAdrCA           ;  (DS:EBX) -  
          INT   INTfcWnd               ;   ⥪饣 .
          XCHG  EBX,EBP

          MOV   AX,DS:[EBP.TxBegX]     ;  ᮫ न
          MOV   BP,DS:[EBP.TxBegY]     ;   ⥪饣 .
          ADD   BX,AX                  ; 
          ADD   SI,AX                  ;  ᮫
          ADD   DX,BP                  ;  न 
          ADD   DI,BP                  ;  ⥪饣 .

          MOV   AX,iPtBoxGfx           ; ᮢ
          INT   INTfcGfx               ;  ࠦ.
          POP   DS
          POPAD
          RET
PutBoxWn ENDP


; 楤 ந 㦭  業஬  (BX,DX),
;  ࠤᮬ  DI, 梥⮬  CH   ⥪饬 .
SetCirWn PROC FAR
          PUSH  AX EBX DX EBP DS
          MOV   EBP,EBX
          MOV   AX,iGetAdrCA           ;  (DS:EBX) -  
          INT   INTfcWnd               ;   ⥪饣 .
          XCHG  EBX,EBP

          ADD   BX,DS:[EBP.TxBegX]     ;  ᮫ न
          ADD   DX,DS:[EBP.TxBegY]     ;   ⥪饣 .
          MOV   AX,iStCirGfx           ; ᮢ
          INT   INTfcGfx               ;  㦭.
          POP   DS EBP DX EBX AX
          RET
SetCirWn ENDP



;                      .


; "" 㭪. 祣    .
;  ࠧ 頥 ࠢ.
NulFnc   PROC FAR              ; ଠ 砫
          RET
NulFnc   ENDP                  ;    㭪樨.
